﻿Public Class Form2
    Public PDS(13) As Integer 'Pin digital status
    Dim counter As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        NotifyIcon1.Visible = True
        Me.Visible = False
    End Sub

    Private Sub Label6_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Label6.MouseEnter
        GroupBox1.Visible = True
    End Sub

    Private Sub Label6_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles Label6.MouseLeave
        GroupBox1.Visible = False
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Form3.Visible = True
    End Sub

    Private Sub Form2_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        NOCONNECTIONMODE.Enabled = True
        counter = 0
        STATUS.Enabled = True
        For i = 0 To 13
            PDS(i) = 0
        Next
    End Sub

    Private Sub NotifyIcon1_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles NotifyIcon1.MouseDoubleClick
        Me.Visible = True
        NotifyIcon1.Visible = False
    End Sub

    Private Sub AbrirToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AbrirToolStripMenuItem.Click
        Me.Visible = True
        Me.Focus()
    End Sub

    Private Sub ToolStripMenuItem1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripMenuItem1.Click
        Me.Close()
    End Sub

    'Algoritmos Independetes

    Sub Sincronizar() 'Sincronizar estado com a placa
        Dim i As Integer
        If Me.Text = "Smart House - Painel de Controlo" Then
            For i = 0 To 13
                Arduino.DigitalWrite(i, PDS(i))
            Next
        End If
    End Sub

    Sub Desligar() 'Desactivar todas as portas do arduino ao sair
        Dim i As Integer
        If Me.Text = "Smart House - Painel de Controlo" Then
            For i = 0 To 13
                Arduino.DigitalPortReport(i, 0)
                Arduino.DigitalWrite(i, 0)
                If i < 6 Then
                    Arduino.AnalogPinReport(i, 0)
                End If
            Next
        End If
    End Sub


    Sub DigitalPortToggle(ByVal Pin() As Integer) 'Funciona como um interuptor
        Dim oPin As Integer
        For Each oPin In Pin
            Arduino.DigitalPortReport(oPin, 0)
            If PDS(oPin) = 0 Then
                PDS(oPin) = 1
            Else
                PDS(oPin) = 0
            End If
            Arduino.DigitalWrite(oPin, PDS(oPin))
        Next
    End Sub

    Sub DigitalPortSet(ByVal Pin() As Integer, ByVal Value As Integer) 'Define um valor para uma determina porta
        Dim oPin As Integer
        For Each oPin In Pin
            PDS(oPin) = Value
            Arduino.DigitalWrite(oPin, PDS(oPin))
        Next
    End Sub

    Sub DigitalPortPWM(ByVal Pin() As Integer, ByVal Value As Integer) 'Define valores PWM, utilizar com o Servo
        Dim oPin As Integer
        For Each oPin In Pin
            Arduino.DigitalPortReport(oPin, 1)
            PDS(oPin) = Value
            Arduino.AnalogWrite(oPin, PDS(oPin))
        Next
    End Sub

    Sub AnalogReact(ByVal AnalogPin As Integer, ByVal SensorLevel As Integer, ByVal ReactDigitalPin() As Integer, ByVal SET_ON As Integer, ByVal SET_OFF As Integer) 'Algoritmo Genérico para utilização com um sensor
        Arduino.AnalogPinReport(AnalogPin, 1)
        If Arduino.AnalogRead(AnalogPin) < SensorLevel Then
            DigitalPortSet(ReactDigitalPin, SET_ON)
        Else
            DigitalPortSet(ReactDigitalPin, SET_OFF)
        End If
    End Sub

    Private Sub Form2_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Form1.Close()
        Form3.Close()
        Desligar()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Sincronizar()
    End Sub

    Private Sub NOCONNECTIONMODE_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NOCONNECTIONMODE.Tick
        If Me.Text <> "Smart House - Painel de Controlo" Then
            Button3.Enabled = False
            Button5.Enabled = False
        End If
        NOCONNECTIONMODE.Enabled = False
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If Button3.Text = "Ligar" Then
            Button3.Text = "Desligar"
            Arduino.Connect()
        Else
            Button3.Text = "Ligar"
            Desligar()
            Arduino.Disconnect()
        End If
    End Sub


    Private Sub STATUS_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles STATUS.Tick
        Dim i As Integer
        Label7.Text = "Porta: " & Arduino.COMPortName
        Label8.Text = "Taxa de Transmissão: " & Arduino.Baud
        If Me.Text = "Smart House - Painel de Controlo" Then
            If Button3.Text = "Desligar" Then
                Label3.Text = Nothing
                For i = 0 To 13
                    Label3.Text = Label3.Text & i & "->" & PDS(i) & "     "
                Next
                Label4.Text = Nothing
                For i = 0 To 5
                    Arduino.AnalogPinReport(i, 1)
                    If i <> 4 Then
                        Label4.Text = Label4.Text & i & "->" & Arduino.AnalogRead(i) & "     "
                    Else
                        Label4.Text = Label4.Text & i & "->" & Arduino.AnalogRead(i) & "  "
                    End If
                Next
                Label6.Text = "Ligação Activa"
                PictureBox1.Image = My.Resources.STATUS_ON

            Else
                Label6.Text = "Ligação Inactiva"
                PictureBox1.Image = My.Resources.STATUS_OFF
                Label4.Text = "Offline"
                Label3.Text = "Offline"
            End If
        End If

    End Sub

    'Controlos ////////////////////////////////////////////////////////////////////////////////////////////////////////

    'SensorLuz
    Private Sub SensorLuz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SensorLuz.Tick
        If (Button3.Text = "Desligar") And (Button3.Enabled = True) Then
            AnalogReact(0, 500, {11}, 1, 0)
        End If
    End Sub

    Private Sub Toggle_Sensor1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Toggle_Sensor1.Click
        If Toggle_Sensor1.Text = "Desactivada" Then
            Toggle_Sensor1.Text = "Activada"
            Toggle_Sensor1.ForeColor = Color.Lime
            SensorLuz.Enabled = True
        Else
            Toggle_Sensor1.Text = "Desactivada"
            Toggle_Sensor1.ForeColor = Color.Red
            SensorLuz.Enabled = False
        End If
    End Sub

    'Alarme
    Private Sub Toggle_Sensor2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Toggle_Sensor2.Click
        If Toggle_Sensor2.Text = "Desactivado" Then
            Toggle_Sensor2.Text = "Activado"
            Toggle_Sensor2.ForeColor = Color.Lime
            SMA.Enabled = True
        ElseIf Toggle_Sensor2.Text = "Activado" Then
            Toggle_Sensor2.Text = "Desactivado"
            Toggle_Sensor2.ForeColor = Color.Yellow
            SMA.Enabled = False
        Else
            Toggle_Sensor2.Text = "Desactivado"
            Toggle_Sensor2.ForeColor = Color.Yellow
            SMA.Enabled = False
        End If
    End Sub

    Private Sub SMA_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SMA.Tick
        Arduino.AnalogPinReport(1, 1)
        If Arduino.AnalogRead(1) = 0 Then
            counter = counter + 1
        Else
            counter = 0
        End If
        If counter > 50 Then
            DigitalPortSet({5}, 1)
            Toggle_Sensor2.Text = "Foi detectada uma intrusão às: " & TimeOfDay.Hour & ":" & TimeOfDay.Minute
            Toggle_Sensor2.ForeColor = Color.Red
            SMB.Enabled = True
            SMA.Enabled = False
            MsgBox("Foi detectada uma intrusão às: " & TimeOfDay.Hour & ":" & TimeOfDay.Minute, MsgBoxStyle.Exclamation)
        End If
    End Sub

    Private Sub SMB_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SMB.Tick
        DigitalPortSet({5}, 0)
        Arduino.AnalogPinReport(1, 0)
        SMB.Enabled = False
        counter = 0
    End Sub

    Private Sub Interruptor1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Interruptor1.Click
        DigitalPortToggle({2})
    End Sub

    Private Sub Interruptor2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Interruptor2.Click
        DigitalPortToggle({7})
    End Sub

    Private Sub Interruptor3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Interruptor3.Click
        DigitalPortToggle({6})
    End Sub

    Private Sub Interruptor4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Interruptor4.Click
        DigitalPortToggle({4})
    End Sub

    Private Sub Interruptor5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Interruptor5.Click
        DigitalPortToggle({3})
    End Sub

    Private Sub Interruptor6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Interruptor6.Click
        DigitalPortToggle({11})
    End Sub

    Private Sub Button2_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button2.MouseDown
        DigitalPortPWM({9}, 70)
    End Sub

    Private Sub Button2_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button2.MouseUp
        DigitalPortPWM({9}, 90)
    End Sub

    Private Sub Button4_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button4.MouseDown
        DigitalPortPWM({9}, 110)
    End Sub

    Private Sub Button4_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Button4.MouseUp
        DigitalPortPWM({9}, 90)
    End Sub
End Class